// Generated by LiveScript 1.4.0
/**
 * @package   CleverStyle Widgets
 * @author    Nazar Mokrynskyi <nazar@mokrynskyi.com>
 * @copyright Copyright (c) 2015-2016, Nazar Mokrynskyi
 * @license   MIT License, see license.txt
 */
(function(){
  Polymer.cs.behaviors.csSelect = [
    Polymer.cs.behaviors.size, Polymer.cs.behaviors.tight, Polymer.cs.behaviors['this'], Polymer.cs.behaviors.tooltip, {
      listeners: {
        'value-changed': '_value_changed'
      },
      properties: {
        selected: {
          notify: true,
          observer: '_selected_changed',
          type: Object
        }
      },
      ready: function(){
        var scroll_once, timeout, callback, this$ = this;
        scroll_once = function(){
          this$._scroll_to_selected();
          document.removeEventListener('WebComponentsReady', scroll_once);
        };
        document.addEventListener('WebComponentsReady', scroll_once);
        timeout = null;
        callback = function(){
          var timeout, height_in_px, font_size;
          clearTimeout(timeout);
          timeout = setTimeout(function(){
            this$.removeEventListener(callback);
            if (this$.selected !== undefined) {
              this$._selected_changed(this$.selected);
            }
          }, 100);
          if (this$._height_updated) {
            return;
          }
          if (this$.size <= 1) {
            this$._height_updated = true;
            return;
          }
          if (this$.querySelectorAll('option').length) {
            height_in_px = this$.querySelector('option').getBoundingClientRect().height * this$.size;
            if (height_in_px === 0) {
              return;
            }
            this$._height_updated = true;
            font_size = parseFloat(getComputedStyle(this$).fontSize);
            this$.style.height = "calc(" + height_in_px + "em / " + font_size + ")";
          }
        };
        this.addEventListener('dom-change', callback);
      },
      _scroll_to_selected: function(){
        var option, option_height, select_height;
        option = this.querySelector('option');
        if (!option) {
          return;
        }
        option_height = option.getBoundingClientRect().height;
        if (this.size > 1 && this.selectedOptions[0]) {
          this.scrollTop = option_height * (this.selectedIndex - Math.floor(this.size / 2)) + this._number_of_optgroups();
        }
        select_height = this.getBoundingClientRect().height;
        if (select_height >= option_height * (this.querySelectorAll('option').length + this.querySelectorAll('optgroup').length)) {
          this.style.overflowY = 'auto';
        }
      },
      _number_of_optgroups: function(){
        var optgroup, count;
        optgroup = this.selectedOptions[0].parentNode;
        count = 0;
        if (optgroup.tagName === 'OPTGROUP') {
          while (optgroup) {
            ++count;
            optgroup = optgroup.previousElementSibling;
          }
        }
        return count;
      },
      _value_changed: function(){
        var selected;
        selected = [];
        Array.prototype.forEach.call(this.selectedOptions, function(option){
          return selected.push(option.value);
        });
        if (!this.multiple) {
          selected = selected[0] || undefined;
        }
        this.set('selected', selected);
      },
      _selected_changed: function(selected){
        if (selected === undefined) {
          return;
        }
        selected = selected instanceof Array
          ? selected.map(String)
          : String(selected);
        Array.prototype.forEach.call(this.querySelectorAll('option'), function(option){
          return option.selected = selected === option.value || (selected instanceof Array && selected.indexOf(option.value) !== -1);
        });
      }
    }
  ];
}).call(this);
